/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.cpu.shared.Shared.*;

public final class J extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         J.class,
         "J",
         true,
         new ArgumentDecls()
             .add("target", INDEX),
         true,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final Location target = (Location) getArgument("target", args);

      return new J(target);
    }
  }

  public static final IInfo INFO = new Info();

  private final Location target;

  public J(Location target) {
    assert INDEX.equals(target.getType());

    this.target = target;
  }

  @Override
  public String syntax() {
    return String.format("j <label>%d", target.load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("011%b", target.load().toBinString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    PC.access().store(target.load());
    } finally {
    actionEnd();
    }
  }
}
