/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class jal extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         jal.class,
         "jal",
         false,
         new ArgumentDecls()
             .add("addr", JUMP_IMM),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final Location addr = (Location) getArgument("addr", args);

      return new jal(addr);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "jal",
          true,
          new ArgumentDecls()
              .add("addr", JUMP_IMM),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final Location addr = (Location) getArgument("addr", args);

      return new instruction(
        new jal(
          addr
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  private final Location addr;

  public jal(Location addr) {
    assert JUMP_IMM.equals(addr.getType());

    this.addr = addr;
  }

  @Override
  public String syntax() {
    return String.format("jal <label>%d", addr.load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("000011%s", addr.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    GPR.access(31).store(CIA.access().load().add(Data.valueOf(WORD, 0x4)).add(Data.valueOf(WORD, 0x4)));
    nia.access().store(CIA.access().load().add(Data.valueOf(WORD, 0x4)));
    temp_jump.access().store(Data.zeroExtend(Type.CARD(28), addr.load()).shiftLeft(Data.valueOf(Type.CARD(28), 0x2)));
    BRANCH.access().store(Data.valueOf(BIT, 0x1));
    JMPADDR.access().store(Location.concat(temp_jump.access(), nia.access().bitField(31, 28)).load());
    } finally {
    actionEnd();
    }
  }
}
