/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class BEQ extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         BEQ.class,
         "BEQ",
         false,
         new ArgumentDecls()
             .add("rs", ArgumentMode.IN, R.INFO)
             .add("rt", ArgumentMode.IN, R.INFO)
             .add("offset", SHORT),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final R rs = (R) getArgument("rs", args);
      final R rt = (R) getArgument("rt", args);
      final Location offset = (Location) getArgument("offset", args);

      return new BEQ(rs, rt, offset);
    }
  }

  public static final IInfo INFO = new Info();

  private final R rs;
  private final R rt;
  private final Location offset;

  public BEQ(R rs, R rt, Location offset) {
    assert R.INFO.isSupported(rs);
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());

    this.rs = rs;
    this.rt = rt;
    this.offset = offset;
  }

  @Override
  public String syntax() {
    return String.format("BEQ %s, %s, <label>%d", rs.syntax(), rt.syntax(), offset.load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("000100%s%s%s", rs.image(), rt.image(), offset.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    if (rs.access().load().equals(rt.access().load())) {
      BRANCH.access().store(Data.valueOf(BIT, 0x1));
      JMPADDR.access().store(NIA.access().load().add(Data.signExtend(WORD, offset.load()).shiftLeft(Data.valueOf(WORD, 0x3))));
    }
    } finally {
    actionEnd();
    }
  }
}
